<template>
  <div>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      <q-space />
      <div class="q-gutter-xs">
        <template v-if="$isCan('eventos.edicion')">
          <q-btn
            flat
            dense
            icon="edit"
            :to="'/eventos/editar/' + uuid"
            label="Editar"
          />
          |
        </template>
        <q-btn
          flat
          dense
          icon="group_add"
          label="Agregar Participante"
          @click="showDialogAgregarParticipantes = true"
        />

        <template v-if="!cerrado">
          |
          <q-btn
            flat
            dense
            icon="mail"
            label="Enviar Mensaje Masivo"
            @click="showDialogMensajeMasivo = true"
          />
          |
          <q-btn
            flat
            dense
            icon="send"
            label="Reenviar Pauta"
            @click="reenvioPauta"
          />
        </template>
      </div>
    </q-toolbar>

    <q-page-sticky
      position="bottom-right"
      :offset="[18, 18]"
      class="z-max lt-md"
    >
      <q-fab
        vertical-actions-align="right"
        color="green"
        direction="up"
        padding="xs"
      >
        <template v-if="$isCan('eventos.edicion')">
          <q-fab-action
            color="primary"
            icon="mail"
            label="Editar"
            :to="'/eventos/editar/' + uuid"
          />
        </template>
        <q-fab-action
          color="secondary"
          icon="group_add"
          label="Agregar Participante"
          @click="showDialogAgregarParticipantes = true"
        />

        <template v-if="!cerrado">
          <q-fab-action
            color="orange"
            icon="mail"
            label="Enviar Mensaje Masivo"
            @click="showDialogMensajeMasivo = true"
          />
          <q-fab-action
            color="accent"
            icon="send"
            label="Reenviar Pauta"
            @click="showDialogMensajeMasivo = true"
          />
        </template>
      </q-fab>
    </q-page-sticky>

    <EnviarMensaje
      :show="showDialogMensajeMasivo"
      @close="showDialogMensajeMasivo = false"
    />
    <AgregarParticipantes
      :show="showDialogAgregarParticipantes"
      @close="showDialogAgregarParticipantes = false"
    >
    </AgregarParticipantes>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from 'vue';
import { useRoute } from 'vue-router';
import { useQuasar } from 'quasar';
import EnviarMensaje from './_AccionesEnviarMensajeMasivoPartial.vue';
import AgregarParticipantes from './_AccionesAgregarParticipantesPartial.vue';
import { api } from 'src/boot/axios/index';
import { useUserStore } from 'src/stores/user';

export default defineComponent({
  name: 'BotonEstadoPartial',
  components: {
    EnviarMensaje,
    AgregarParticipantes,
  },
  props: {
    uuid: {
      type: String,
      required: true,
    },
    cerrado: {
      type: Boolean,
      required: true,
    },
  },
  setup() {
    const store = useUserStore();
    const $q = useQuasar();
    const route = useRoute();
    const uuid = route.params.uuid || '';

    const showDialogMensajeMasivo = ref(false);
    const showDialogAgregarParticipantes = ref(false);

    function reenvioPauta() {
      $q.dialog({
        title: 'Renvio de Pauta',
        message:
          'Esta seguro que quiere Reenviar la pauta del evento a todos los participantes?',
        persistent: true,
        ok: {
          color: 'red',
          label: 'Renviar Pauta',
        },
        cancel: {
          color: 'green',
          label: 'Cancelar !',
        },
      })
        .onOk(() => {
          api.post('/api/eventos/eventos/email/reenviar_pauta', {
            uuid: uuid,
          });
        })
        .onCancel(() => {
          $q.notify({
            message: 'Accion cancelada',
            color: 'red',
            position: 'top',
          });
        });
    }

    return {
      user: store.details,
      showDialogMensajeMasivo,
      showDialogAgregarParticipantes,
      reenvioPauta,
    };
  },
});
</script>
